# Robust Normal Estimation in point clouds

## Paper

* Title: 	Iterative weighted PCA for robust and edge-aware normal vector estimation.

* Authors: 	Julia Sanchez, Florence Denis, David Coeurjolly, Laurent Trassoudaine, Paul Checchin.

* Year: 	2019.

## Dependencies

* Flann: included in external

* Eigen: included in external

* OpenMP: to install


## Input/Output files

* Extension: ".csv"

* Header: "x, y, z, nx, ny, nz"

* Data: x, y, z, normal_x, normal_y, normal_z

## Compilation

```
    $ cd normal_estimation
    $ mkdir build
    $ cd build
    $ cmake -B. -H..
    $ make 
```
## Running

### Parameters

* N: number of neighbors.

* sigma: Standard deviation of the estimated Gaussian noise (in meters).

* Rmin: Minimum curvature radius to tolerate a smooth region with high curvature (in meters),
if neighborhood curvature radius is lower than Rmin, it is considered as sharp feature.

```
    $ ./normal_estimation file.csv N sigma Rmin
```

